<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8" name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <title>Document</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- Import DataTable Library -->
    <link rel="stylesheet" href="//cdn.datatables.net/1.13.4/css/jquery.dataTables.min.css">
    <script src="//cdn.datatables.net/1.13.4/js/jquery.dataTables.min.js"></script>
</head>
<body>
    <div class="container">
        <div class="text-center mt-2 mb-2">
            <h2>F200 - LỊCH SỬ VOUCHER</h2>
        </div>
        <div class="jumbotron container">
            <div class="row form-group">
                <h5>Thông tin người chơi: </h5>
            </div>
            <div class="row form-group">
                <div class="col-sm-1">
                    <label for="">Username</label>
                </div>
                <div class="col-sm-3">
                    <input id="inp-username" type="text" class="form-control bg-info text-white">
                </div>
                <div class="col-sm-1">
                    <label for="">Firstname</label>
                </div>
                <div class="col-sm-3">
                    <input id="inp-firstname" type="text" class="form-control bg-info text-white">
                </div>
                <div class="col-sm-1">
                    <label for="">Lastname</label>
                </div>
                <div>
                    <input id="inp-lastname" type="text" class="form-control bg-info text-white">
                </div>
            </div>
    </div>
    <div class="container">
        <table class="table table-bordered table-hover table-striped text-white bg-info" id="table-history-voucher">
            <thead>
                <tr>
                    <th>STT</th>
                    <th>Mã Voucher</th>
                    <th>Phần trăm giảm giá</th>
                    <th>Ngày tạo</th>
                </tr>
            </thead>
        </table>
    </div>
</body>
<script>
    "use strict";
    //REGION 1
    var gName_Col = ["id", "maVoucher", "phanTramGiamGia", "ngayTao"];
    const gSTT_COL = 0;
    const gMA_VOUCHER_COL = 1;
    const gPHANTRAM_COL = 2;
    const gNGAYTAO_COL = 3;
    var gTable = $("#table-history-voucher").DataTable({
        columns: [
            {data: gName_Col[gSTT_COL]},
            {data: gName_Col[gMA_VOUCHER_COL]},
            {data: gName_Col[gPHANTRAM_COL]},
            {data: gName_Col[gNGAYTAO_COL]},
        ],
        columnDefs: [
            {
                targets: gSTT_COL,
                render: function(data, type, row, meta){
                    return meta.row + meta.settings._iDisplayStar + 1;
                }
            }
        ]
    })
    //REGION 2
    onPageLoading()
    //REGION 3
    function onPageLoading(){
        var vUrlQueryString = window.location.href // gọi đường dẫn
        var vNewUrl = new URL(vUrlQueryString);
        var vUserName = vNewUrl.searchParams.get("username");
        var vFirstName = vNewUrl.searchParams.get("firstname");
        var vLastName = vNewUrl.searchParams.get("lastname");
        
        $("#inp-username").val(vUserName);
        $("#inp-firstname").val(vFirstName);
        $("#inp-lastname").val(vLastName);

        callApiGetHistoryVoucher(vUserName);
    }
    //REGION 4
    //hàm gọi api lấy danh sách lịch sử voucher
    function callApiGetHistoryVoucher(paramUser){
        $.ajax({
            url:  "http://203.171.20.210:8080/devcamp-lucky-dice" + "/voucher-history?username=" + paramUser,
            type: "GET",
            dataType: "json",
            success: function(response){
                console.log(response)
                //hiển thị danh sách lịch sử voucher lên table
                displayTableVoucher(response)
            },
            error: function(err){
                console.log(err.responseText);
            }
        })
    }
    //hàm hiển thị danh sách voucher ra bản
    function displayTableVoucher(paramRes){
        var vTable = $("#table-history-voucher"); //truy xuất data table
        for (let bI = 0; bI < paramRes.vouchers.length; bI++){
            var bNeRow = $("<tr>").appendTo(vTable);
                $("<td>", {
                    text: bI + 1
                }).appendTo(bNeRow);
                $("<td>", {
                    text: paramRes.vouchers[bI].maVoucher}
                ).appendTo(bNeRow);
                $("<td>", {
                    text: paramRes.vouchers[bI].phanTramGiamGia
                }).appendTo(bNeRow);
                $("<td>", {
                    text: paramRes.vouchers[bI].ngayTao
                }).appendTo(bNeRow)
        }
    }
</script>
</html>